<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>CommitProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">CommitProcessor.java</span></div><h1>CommitProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.util.ArrayList;
import java.util.LinkedList;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.ZooKeeperCriticalThread;
import org.apache.zookeeper.server.ZooKeeperServerListener;

/**
 * This RequestProcessor matches the incoming committed requests with the
 * locally submitted requests. The trick is that locally submitted requests that
 * change the state of the system will come back as incoming committed requests,
 * so we need to match them up.
 */
public class CommitProcessor extends ZooKeeperCriticalThread implements RequestProcessor {
<span class="fc" id="L39">    private static final Logger LOG = LoggerFactory.getLogger(CommitProcessor.class);</span>

    /**
     * Requests that we are holding until the commit comes in.
     */
<span class="fc" id="L44">    LinkedList&lt;Request&gt; queuedRequests = new LinkedList&lt;Request&gt;();</span>

    /**
     * Requests that have been committed.
     */
<span class="fc" id="L49">    LinkedList&lt;Request&gt; committedRequests = new LinkedList&lt;Request&gt;();</span>

    RequestProcessor nextProcessor;
<span class="fc" id="L52">    ArrayList&lt;Request&gt; toProcess = new ArrayList&lt;Request&gt;();</span>

    /**
     * This flag indicates whether we need to wait for a response to come back from the
     * leader or we just let the sync operation flow through like a read. The flag will
     * be true if the CommitProcessor is in a Leader pipeline.
     */
    boolean matchSyncs;

    public CommitProcessor(RequestProcessor nextProcessor, String id,
            boolean matchSyncs, ZooKeeperServerListener listener) {
<span class="fc" id="L63">        super(&quot;CommitProcessor:&quot; + id, listener);</span>
<span class="fc" id="L64">        this.nextProcessor = nextProcessor;</span>
<span class="fc" id="L65">        this.matchSyncs = matchSyncs;</span>
<span class="fc" id="L66">    }</span>

<span class="fc" id="L68">    volatile boolean finished = false;</span>

    @Override
    public void run() {
        try {
<span class="fc" id="L73">            Request nextPending = null;            </span>
<span class="fc bfc" id="L74" title="All 2 branches covered.">            while (!finished) {</span>
<span class="fc" id="L75">                int len = toProcess.size();</span>
<span class="fc bfc" id="L76" title="All 2 branches covered.">                for (int i = 0; i &lt; len; i++) {</span>
<span class="fc" id="L77">                    nextProcessor.processRequest(toProcess.get(i));</span>
                }
<span class="fc" id="L79">                toProcess.clear();</span>
<span class="fc" id="L80">                synchronized (this) {</span>
<span class="fc bfc" id="L81" title="All 4 branches covered.">                    if ((queuedRequests.size() == 0 || nextPending != null)</span>
<span class="fc bfc" id="L82" title="All 2 branches covered.">                            &amp;&amp; committedRequests.size() == 0) {</span>
<span class="fc" id="L83">                        wait();</span>
<span class="fc" id="L84">                        continue;</span>
                    }
                    // First check and see if the commit came in for the pending
                    // request
<span class="fc bfc" id="L88" title="All 4 branches covered.">                    if ((queuedRequests.size() == 0 || nextPending != null)</span>
<span class="pc bpc" id="L89" title="1 of 2 branches missed.">                            &amp;&amp; committedRequests.size() &gt; 0) {</span>
<span class="fc" id="L90">                        Request r = committedRequests.remove();</span>
                        /*
                         * We match with nextPending so that we can move to the
                         * next request when it is committed. We also want to
                         * use nextPending because it has the cnxn member set
                         * properly.
                         */
<span class="pc bpc" id="L97" title="1 of 6 branches missed.">                        if (nextPending != null</span>
                                &amp;&amp; nextPending.sessionId == r.sessionId
                                &amp;&amp; nextPending.cxid == r.cxid) {
                            // we want to send our version of the request.
                            // the pointer to the connection in the request
<span class="fc" id="L102">                            nextPending.hdr = r.hdr;</span>
<span class="fc" id="L103">                            nextPending.txn = r.txn;</span>
<span class="fc" id="L104">                            nextPending.zxid = r.zxid;</span>
<span class="fc" id="L105">                            toProcess.add(nextPending);</span>
<span class="fc" id="L106">                            nextPending = null;</span>
                        } else {
                            // this request came from someone else so just
                            // send the commit packet
<span class="fc" id="L110">                            toProcess.add(r);</span>
                        }
                    }
<span class="pc" id="L113">                }</span>

                // We haven't matched the pending requests, so go back to
                // waiting
<span class="fc bfc" id="L117" title="All 2 branches covered.">                if (nextPending != null) {</span>
<span class="fc" id="L118">                    continue;</span>
                }

<span class="fc" id="L121">                synchronized (this) {</span>
                    // Process the next requests in the queuedRequests
<span class="fc bfc" id="L123" title="All 4 branches covered.">                    while (nextPending == null &amp;&amp; queuedRequests.size() &gt; 0) {</span>
<span class="fc" id="L124">                        Request request = queuedRequests.remove();</span>
<span class="fc bfc" id="L125" title="All 3 branches covered.">                        switch (request.type) {</span>
                        case OpCode.create:
                        case OpCode.delete:
                        case OpCode.setData:
                        case OpCode.multi:
                        case OpCode.setACL:
                        case OpCode.createSession:
                        case OpCode.closeSession:
<span class="fc" id="L133">                            nextPending = request;</span>
<span class="fc" id="L134">                            break;</span>
                        case OpCode.sync:
<span class="fc bfc" id="L136" title="All 2 branches covered.">                            if (matchSyncs) {</span>
<span class="fc" id="L137">                                nextPending = request;</span>
                            } else {
<span class="fc" id="L139">                                toProcess.add(request);</span>
                            }
<span class="fc" id="L141">                            break;</span>
                        default:
<span class="fc" id="L143">                            toProcess.add(request);</span>
                        }
<span class="fc" id="L145">                    }</span>
<span class="pc" id="L146">                }</span>
<span class="fc" id="L147">            }</span>
<span class="nc" id="L148">        } catch (InterruptedException e) {</span>
<span class="nc" id="L149">            LOG.warn(&quot;Interrupted exception while waiting&quot;, e);</span>
<span class="nc" id="L150">        } catch (Throwable e) {</span>
<span class="nc" id="L151">            LOG.error(&quot;Unexpected exception causing CommitProcessor to exit&quot;, e);</span>
<span class="pc" id="L152">        }</span>
<span class="fc" id="L153">        LOG.info(&quot;CommitProcessor exited loop!&quot;);</span>
<span class="fc" id="L154">    }</span>

    synchronized public void commit(Request request) {
<span class="pc bpc" id="L157" title="1 of 2 branches missed.">        if (!finished) {</span>
<span class="pc bpc" id="L158" title="1 of 2 branches missed.">            if (request == null) {</span>
<span class="nc" id="L159">                LOG.warn(&quot;Committed a null!&quot;,</span>
                         new Exception(&quot;committing a null! &quot;));
<span class="nc" id="L161">                return;</span>
            }
<span class="pc bpc" id="L163" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L164">                LOG.debug(&quot;Committing request:: &quot; + request);</span>
            }
<span class="fc" id="L166">            committedRequests.add(request);</span>
<span class="fc" id="L167">            notifyAll();</span>
        }
<span class="fc" id="L169">    }</span>

    synchronized public void processRequest(Request request) {
        // request.addRQRec(&quot;&gt;commit&quot;);
<span class="pc bpc" id="L173" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L174">            LOG.debug(&quot;Processing request:: &quot; + request);</span>
        }
        
<span class="pc bpc" id="L177" title="1 of 2 branches missed.">        if (!finished) {</span>
<span class="fc" id="L178">            queuedRequests.add(request);</span>
<span class="fc" id="L179">            notifyAll();</span>
        }
<span class="fc" id="L181">    }</span>

    public void shutdown() {
<span class="fc" id="L184">        LOG.info(&quot;Shutting down&quot;);</span>
<span class="fc" id="L185">        synchronized (this) {</span>
<span class="fc" id="L186">            finished = true;</span>
<span class="fc" id="L187">            queuedRequests.clear();</span>
<span class="fc" id="L188">            notifyAll();</span>
<span class="pc" id="L189">        }</span>
<span class="pc bpc" id="L190" title="1 of 2 branches missed.">        if (nextProcessor != null) {</span>
<span class="fc" id="L191">            nextProcessor.shutdown();</span>
        }
<span class="fc" id="L193">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>